VERSION 5.00
Begin VB.Form frmAddEdit 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Add Pair"
   ClientHeight    =   4455
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6885
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   4455
   ScaleWidth      =   6885
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   5400
      TabIndex        =   12
      Top             =   3960
      Width           =   1335
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   "Add"
      Height          =   375
      Left            =   120
      TabIndex        =   11
      Top             =   3960
      Width           =   1335
   End
   Begin VB.OptionButton optMaxFoc 
      Caption         =   "vbMaximizedFocus"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   3360
      Width           =   1695
   End
   Begin VB.OptionButton optNormNoFoc 
      Caption         =   "vbNormalNoFocus"
      Height          =   255
      Left            =   120
      TabIndex        =   10
      Top             =   3120
      Width           =   1695
   End
   Begin VB.OptionButton optNormFoc 
      Caption         =   "vbNormalFocus"
      Height          =   255
      Left            =   120
      TabIndex        =   9
      Top             =   2880
      Width           =   1455
   End
   Begin VB.OptionButton optMinNoFoc 
      Caption         =   "vbMinimizedNoFocus"
      Height          =   255
      Left            =   120
      TabIndex        =   8
      Top             =   2640
      Width           =   1815
   End
   Begin VB.OptionButton optMinFoc 
      Caption         =   "vbMinimizedFocus"
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   2400
      Width           =   1815
   End
   Begin VB.OptionButton optHide 
      Caption         =   "vbHide"
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   2160
      Width           =   855
   End
   Begin VB.TextBox txtShell 
      Height          =   375
      Left            =   120
      TabIndex        =   3
      Top             =   1320
      Width           =   6615
   End
   Begin VB.TextBox txtString 
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   360
      Width           =   6615
   End
   Begin VB.Label Label1 
      Caption         =   "Chose a window state:"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   1920
      Width           =   1695
   End
   Begin VB.Label lblShell 
      Caption         =   "Enter the shell command to be run:"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   960
      Width           =   2535
   End
   Begin VB.Label lblString 
      Caption         =   "Enter the string to be paired with the Fat Controller results:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4335
   End
End
Attribute VB_Name = "frmAddEdit"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim intFocus As Integer

Private Sub cmdCancel_Click()
'Just hide the form without changing anything
Me.Hide
End Sub

Private Sub cmdSave_Click()

'Make sure the requied fields have been filled out
If txtString.Text = "" Then
    MsgBox "Enter a voice command", vbOKOnly, "Thomas - Add Pair"
    txtString.SetFocus
    Exit Sub
End If
If txtShell.Text = "" Then
    MsgBox "Enter a command to execute", vbOKOnly, "Thomas - Add Pair"
    txtShell.SetFocus
    Exit Sub
End If

'If this is a new entry add it to the list of commands...
If frmMain.bolEdit = False Then
    frmMain.lstPattern.AddItem txtString.Text
    frmMain.lstCommand.AddItem txtShell.Text
    frmMain.lstFocus.AddItem intFocus
    frmMain.Log "Added voice command [" & txtString.Text & "] to execute: " & txtShell.Text
End If
If frmMain.bolEdit = True Then 'Or if editing an existing one, update the existing entry
    frmMain.lstPattern.List(frmMain.lstPattern.ListIndex) = txtString.Text
    frmMain.lstCommand.List(frmMain.lstCommand.ListIndex) = txtShell.Text
    frmMain.lstFocus.List(frmMain.lstFocus.ListIndex) = intFocus
    frmMain.Log "Updated entry, voice command [" & txtString.Text & "] will execute: " & txtShell.Text
End If

Me.Hide
End Sub

Private Sub Form_Activate()
'Change the form apperance depending on weather we are editing an existing entry or adding a new one
txtString.Text = ""
txtShell.Text = ""
optHide.Value = False
optMaxFoc.Value = False
optMinFoc.Value = False
optMinNoFoc.Value = False
optNormFoc.Value = False
optNormNoFoc.Value = False
intFocus = 0

If frmMain.bolEdit = True Then
    Me.Caption = "Edit Pair"
    cmdSave.Caption = "Save"
    txtString.Text = frmMain.lstPattern.Text
    txtShell.Text = frmMain.lstCommand.Text
    Select Case frmMain.lstFocus.Text
        Case 0
            optHide.Value = True
            intFocus = 0
        Case 1
            optNormFoc.Value = True
            intFocus = 1
        Case 2
            optMinFoc.Value = True
            intFocus = 2
        Case 3
            optMaxFoc.Value = True
            intFocus = 3
        Case 4
            optNormNoFoc.Value = True
            intFocus = 4
        Case 6
            optMinNoFoc.Value = True
            intFocus = 6
    End Select
End If
If frmMain.bolEdit = False Then
    Me.Caption = "Add Pair"
    cmdSave.Caption = "Add"
    optNormFoc.Value = True
End If

End Sub

Private Sub optHide_Click()
intFocus = 0
End Sub

Private Sub optMaxFoc_Click()
intFocus = 3
End Sub

Private Sub optMinFoc_Click()
intFocus = 2
End Sub

Private Sub optMinNoFoc_Click()
intFocus = 6
End Sub

Private Sub optNormFoc_Click()
intFocus = 1
End Sub

Private Sub optNormNoFoc_Click()
intFocus = 4
End Sub
