VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Thomas"
   ClientHeight    =   5880
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   12285
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   5880
   ScaleWidth      =   12285
   StartUpPosition =   2  'CenterScreen
   Begin VB.Timer tmrWinsock 
      Enabled         =   0   'False
      Interval        =   1000
      Left            =   3360
      Top             =   1440
   End
   Begin MSWinsockLib.Winsock wckTCP 
      Left            =   3360
      Top             =   840
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
      LocalPort       =   2011
   End
   Begin VB.CommandButton cmdRun 
      Caption         =   "Run"
      Height          =   255
      Left            =   10200
      TabIndex        =   14
      Top             =   120
      Width           =   1335
   End
   Begin VB.ListBox lstFocus 
      Height          =   3180
      Left            =   12480
      TabIndex        =   13
      Top             =   840
      Width           =   975
   End
   Begin VB.TextBox txtPort 
      Height          =   285
      Left            =   840
      TabIndex        =   11
      Text            =   "2011"
      Top             =   120
      Width           =   615
   End
   Begin VB.CommandButton cmdListen 
      Caption         =   "Listen"
      Height          =   255
      Left            =   1560
      TabIndex        =   10
      Top             =   120
      Width           =   1335
   End
   Begin VB.CommandButton cmdClear 
      Caption         =   "Clear Log"
      Height          =   255
      Left            =   11280
      TabIndex        =   9
      Top             =   4200
      Width           =   975
   End
   Begin VB.ListBox lstLog 
      Height          =   1425
      Left            =   0
      TabIndex        =   7
      Top             =   4440
      Width           =   12255
   End
   Begin VB.CommandButton cmdNew 
      Caption         =   "New string/command pair"
      Height          =   255
      Left            =   3960
      TabIndex        =   6
      Top             =   120
      Width           =   2175
   End
   Begin VB.CommandButton cmdEdit 
      Caption         =   "Edit Selection"
      Height          =   255
      Left            =   6600
      TabIndex        =   5
      Top             =   120
      Width           =   1335
   End
   Begin VB.CommandButton cmdDel 
      Caption         =   "Delete Selection"
      Height          =   255
      Left            =   8400
      TabIndex        =   4
      Top             =   120
      Width           =   1335
   End
   Begin VB.ListBox lstCommand 
      Height          =   3375
      Left            =   3960
      TabIndex        =   2
      Top             =   720
      Width           =   8295
   End
   Begin VB.ListBox lstPattern 
      Height          =   3375
      Left            =   0
      TabIndex        =   0
      Top             =   720
      Width           =   3855
   End
   Begin VB.Label lblTCP 
      Caption         =   "TCP Port:"
      Height          =   255
      Left            =   0
      TabIndex        =   12
      Top             =   120
      Width           =   735
   End
   Begin VB.Label lblLog 
      Caption         =   "Output Log:"
      Height          =   255
      Left            =   0
      TabIndex        =   8
      Top             =   4200
      Width           =   975
   End
   Begin VB.Label lblShell 
      Caption         =   "Shell Command:"
      Height          =   255
      Left            =   3960
      TabIndex        =   3
      Top             =   480
      Width           =   1215
   End
   Begin VB.Label lblSpeech 
      Caption         =   "Speech Pattern:"
      Height          =   255
      Left            =   0
      TabIndex        =   1
      Top             =   480
      Width           =   1215
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'
' Thomas / Fat Controller by James Bensley
' jwbensley@gmail.com 01-2011 (Still using VB6!)
'
' This is the VB end to the Fat Controller Android App
' It receives a text string and has an associated shell command and executes the shell command
'
'
Option Explicit
Public bolEdit As Boolean 'A public boolean to say if we are going to edit an exiting entry or add a new one
Public intLoop As Integer 'Generic integer used for various loops throughout rather than defining many local variables
Private m_cIni As New cIniFile 'Interface of the ini file class

Public Sub Log(strLog As String)
'Public sub to add date and time stamped entries to the log window
lstLog.AddItem Date & "@" & Time & " " & strLog
lstLog.ListIndex = lstLog.ListCount - 1 'Keep the log scrolling down with the entries as they are added
End Sub

Public Sub RunCommand()
'This sub runs the command located at "intIndex" in the list, in the matching focus
Dim intFocus As Integer
intFocus = lstFocus.Text
Shell lstCommand.Text, intFocus
Log "Executing: " & lstCommand.Text
End Sub

Private Sub cmdClear_Click()
'This buttons clears the log at the bottom of the window
lstLog.Clear
Log "Log cleared"
End Sub

Private Sub cmdDel_Click()
If lstPattern.Text <> "" Then 'Make sure the user has selected an entry
    Dim intAnswer As Integer
    'Then make sure they meant to delete it!
    intAnswer = MsgBox("Are you sure you want to delete this entry?", vbYesNo, "Thomas - " & lstPattern.Text)
    If intAnswer = vbYes Then
        lstPattern.RemoveItem (lstPattern.ListIndex)
        lstCommand.RemoveItem (lstCommand.ListIndex)
        lstFocus.RemoveItem (lstFocus.ListIndex)
    End If
End If
End Sub

Private Sub cmdEdit_Click()
If lstPattern.Text <> "" Then 'Make sure a list item is selected
    bolEdit = True
    frmAddEdit.Show
End If
End Sub

Private Sub cmdListen_Click()
'Start listening on the specified TCP port
On Error GoTo errmsg

If cmdListen.Caption = "Listen" Then 'If we aren't already listening, start!
    wckTCP.LocalPort = txtPort.Text
    wckTCP.Listen
    cmdListen.Caption = "Stop"
    Log "Thomas started listening on " & wckTCP.LocalIP & " TCP " & wckTCP.LocalPort
    tmrWinsock.Enabled = True
Else 'Else, if we are, stop!
    wckTCP.Close
    cmdListen.Caption = "Listen"
    Log "Thomas stopped listening"
    tmrWinsock.Enabled = False
End If

Exit Sub

errmsg: 'If anythings wrong, bug the user...
    cmdListen.Caption = "Listen"
    MsgBox "Please specify a TCP port that is valid and not in use", vbOKOnly, "Thomas"
    txtPort.SetFocus
End Sub

Private Sub cmdNew_Click()
bolEdit = False
frmAddEdit.Show
End Sub

Private Sub cmdRun_Click()
'Make sure something is selected
If lstPattern.Text <> "" Then
    RunCommand
End If
End Sub

Private Sub Form_Load()
Log "Thomas started"

Dim strKeys() As String
Dim lngKeysCount As Long

With m_cIni 'Lets load up our pairs from an INI file
    .Path = App.Path & "\" & App.EXEName & ".ini" 'Stored in the app path as "Thomas.ini"
    .Section = "pairs"
    .EnumerateCurrentSection strKeys, lngKeysCount 'Get the number of entires in the "pairs" section

    For intLoop = 0 To ((lngKeysCount / 3) - 1) 'Since there are three parts (text pattern, command to execute, and focus) loop round a third of the number of entries
DropOut:
        .Key = "pattern" & intLoop 'Extract all the values and populate the list boxes
        If .Value = "" Then
            intLoop = intLoop + 1
            GoTo DropOut
        End If
        lstPattern.AddItem .Value
        .Key = "command" & intLoop
        lstCommand.AddItem .Value
        .Key = "focus" & intLoop
        lstFocus.AddItem .Value
    Next
End With

'Dummies
'lstPattern.AddItem "command"
'lstCommand.AddItem "cmd"
'lstFocus.AddItem "1"
'lstPattern.AddItem "bbc 1"
'lstCommand.AddItem Chr(34) & "C:\Documents and Settings\Administrator\Local Settings\Application Data\Google\Chrome\Application\chrome.exe" & Chr(34) & " http://www.tvcatchup.com/watch.html?c=1"
'lstFocus.AddItem "1"
'lstPattern.AddItem "music please"
'lstCommand.AddItem Chr(34) & "C:\Program Files (x86)\foobar2000\foobar2000.exe" & Chr(34) & " /play"
'lstFocus.AddItem "1"
cmdListen_Click

End Sub

Private Sub Form_Unload(Cancel As Integer)
'Update the setting in the INI file on close
With m_cIni 'First, clear out the existing settings
    .Section = "pairs"
    .DeleteSection
End With

For intLoop = 0 To lstPattern.ListCount - 1 'Loop round the number of list items and populate the ini file
    lstPattern.ListIndex = intLoop
    lstCommand.ListIndex = intLoop
    lstFocus.ListIndex = intLoop
    With m_cIni
        .Key = "pattern" & intLoop
        .Value = lstPattern.Text
        .Key = "command" & intLoop
        .Value = lstCommand.Text
        .Key = "focus" & intLoop
        .Value = lstFocus.Text
    End With
Next

End Sub

Private Sub lstCommand_Click() 'If the user clicks a command, make sure the corresponding voice string and focus option is selected
lstPattern.ListIndex = lstCommand.ListIndex
lstFocus.ListIndex = lstCommand.ListIndex
End Sub

Private Sub lstFocus_Click() 'If the user clicks a focus option, make sure the corresponding voice string and command is selected
lstPattern.ListIndex = lstFocus.ListIndex
lstCommand.ListIndex = lstFocus.ListIndex
End Sub

Private Sub lstPattern_Click() 'If the user clicks a voice string, make sure the corresponding command and focus option is selected
lstCommand.ListIndex = lstPattern.ListIndex
lstFocus.ListIndex = lstPattern.ListIndex
End Sub

Private Sub tmrWinsock_Timer()
'This timer checks the state of the Winsock connection, if it is in an error state,
'or the remote client has disconnected we will retart the connection

'If the socket has changed to the closing state restart the socket
'(This tends to happen if the clients dropps out unexpectedly meaning they cant reconnect)
If wckTCP.State = 8 Then
    Log "Restarting (client connetion lost)"
    wckTCP.Close
    wckTCP.Listen
    Log "Thomas started listening on " & wckTCP.LocalIP & " TCP " & wckTCP.LocalPort
End If

'If the socket has changed to the error state restart the socket
If wckTCP.State = 9 Then
    Log "Restarting (socket state is error)"
    wckTCP.Close
    wckTCP.Listen
    Log "Thomas started listening on " & wckTCP.LocalIP & " TCP " & wckTCP.LocalPort
End If
End Sub

Private Sub wckTCP_ConnectionRequest(ByVal requestID As Long)
wckTCP.Close
wckTCP.Accept requestID
Log "Connection from " & wckTCP.RemoteHostIP & ":" & wckTCP.RemotePort & " established"
End Sub

Private Sub wckTCP_DataArrival(ByVal bytesTotal As Long)

Dim strData As String
wckTCP.GetData strData

Log "Received voice string: " & strData

'Grab the sent data ^ and then loop through all the voice strings stored to find a match,
'if one is found, execute the matching command
Dim intLoopCounter As Integer

For intLoopCounter = 0 To lstPattern.ListCount - 1
    
    If lstPattern.List(intLoopCounter) = strData Then
        lstPattern.ListIndex = intLoopCounter
        lstCommand.ListIndex = intLoopCounter
        lstFocus.ListIndex = intLoopCounter
        RunCommand
        Exit Sub
    End If
    
Next

Log "No matching voice string found!"

End Sub
